;
; Possible values for portInfo.sMedia;
;
MEDIA_PHYSICAL	equ	1
MEDIA_NETWORK	equ	2

MAXCOM		equ	9
MAX_HOSTNAME	equ	256
MAX_TERMTYPE	equ	48
MAX_INI_SIZE	equ	32

portInfo	STRUC
	sComPort	dw	?	; 0 = COM1, 1 = COM2, etc.
	sMedia		dw	?	;
					;
	usComErr	dw	?	; Status of last COM action.
	usEvtMask	dw	?	; Event flag mask.
	usEvtFlag	dw	?	; Event flag.
	lpDcb		dw	?, ?	;
	hwndNotify	dw	?	; Used to notify caller of event change.
	usNotifyFlags	dw	?	; Indicated if caller already notified.
					;
	iSock		dw	?	;
	hwndWndProc	dw	?	; Handle of Port's Window Procedure.
					;
	lpRxQueue	dd	?	;
	usRxSize	dw	?	;
	lpTxQueue	dd	?	;
	usTxSize	dw	?	;
	.errnz	usRxSize - lpRxQueue - 4; The previous 4 fields must remain
	.errnz	lpTxQueue - usRxSize - 2;    their current size, and in their
	.errnz	usTxSize - lpTxQueue - 4;    current order.
					;
	usRxCurLen	dw	?	;
	usTxCurLen	dw	?	;
	sRxTrigger	dw	?	;
	sTxTrigger	dw	?	;
					;
	ucIACEcho	db	?	; 1 = Remote Echo.  0 = Local Echo.
	ucMSRShadow	db	?	;
					;
	usRcvFlag	dw	?	;
					;
	ucMode          db  ?   ; 0 = ascii, 1 = binary
	ucOrgDataLen    db  ?   ; 0 = 7-bit, 1 = 8-bit
	ucDataLength	db	?	; 0 = 7-bit.  1 = 8-bit
	ucIACBuf	db	4 dup (?);IAC negotiation buffer
	cIACSub		db	11 dup (?);subnegotiation buffer
					;
	ucIACFlag	db	?	; bit0 (01h) = DO echo acknowledgement
					; bit1 (02h) = DO SPGA acknowledgement
					; bit2 (04h) = WILL SPGA acknowledgement
					; bit3 (08h) = DO BINARY acknowledgement
					; bit4 (10h) = WILL BINARY acknowledgement
					; bit5 (20h) = WILL TERMINAL-TYPE acknowledgement
					; bit6 UNUSED
					; bit7 (80h) = DUPLEX acknowledgement
					;
	ucIACSet	db	?	; bit0 (01h) = 0  DONT echo setting
					; bit0 (01h) = 1  DO echo setting
					; bit1 (02h) = 0  DONT SPGA setting
					; bit1 (02h) = 1  DO SPGA setting
					; bit2 (04h) = 0  WONT SPGA setting
					; bit2 (04h) = 1  WILL SPGA setting
					; bit3 (08h) = 0  DONT BINARY setting
					; bit3 (08h) = 1  DO BINARY setting
					; bit4 (10h) = 0  WONT BINARY setting
					; bit4 (10h) = 1  WILL BINARY setting
					; bit5 (20h) = 0  WONT TERMINAL-TYPE setting
					; bit5 (20h) = 1  WILL TERMINAL-TYPE setting
					;
	cIncomp		db	?	;incomplete protocal flag
	cIACFunct	db	?	;storage for IAC function
	cSPGACnt	db	?	;
	cIACTrouble	db	?	;
	;
	; ALL of the remaining parameters are used during session startup and 
	; negotiation.  Once the session is established, these parameters are no
	; longer needed or used.
	;
	hwndDlg		dw	?
	
	szIniMedia	db	MAX_INI_SIZE dup (?)
	szIniHost	db	MAX_INI_SIZE dup (?)
	szIniTerm	db	MAX_INI_SIZE dup (?)
	szIniPort	db	MAX_INI_SIZE dup (?)

	szHost		db	MAX_HOSTNAME dup (?)
	szTermType	db	MAX_TERMTYPE dup (?)
	sTermTypeLen	dw	?	;
	uiTcpPort	dw	?	;
	uiTimer		dw	?	;
	iTimer		dw	?	;
	ucIacSetHold	db	?	;

portInfo	ENDS

;
; IBMCOM.INC (in the COM Driver sources in the Windows 3.1 DDK) explains that
; some COM Programs expect the MSRShadow to be 35 bytes after the Event Flag.
; As a result, we'll maintain an MSRShadow at the same offset.
;
.errnz ucMSRShadow - usEvtFlag - 35

usNotifyFlagsLO	equ byte ptr usNotifyFlags
usNotifyFlagsHI	equ byte ptr usNotifyFlags+1
